## ?q=aHR0cHM6Ly9HaXRodWIuY29tL2RtdGNwL2RtdGNwL2FyY2hpdmUvcmVmcy90YWdzLzIuNS4yLnppcA

=== manpages/Makefile ===
# This is the version of latex2man of 2017/10/03, with bug fixes from the author
# Since this will be invoked only by developers, delete local latex2man
#   when the author's version makes its way into our current distro.
LATEX2MAN=./latex2man
hdr=header.tex
ftr=footer.tex
macros=macros.trans
tmp=tmp.tex
vtmp=vtmp.tex

targets = dmtcp_command dmtcp_coordinator dmtcp_launch dmtcp_restart

default:
	echo "\setVersion{`cat ../VERSION`}" > $(vtmp)
	echo "\setDate{`date +"%B, %Y"`}" >> $(vtmp)
	for i in $(targets); do \
	  (cat $(hdr) $(vtmp) $$i.latex2man $(ftr) > $(tmp) && \
	   ${LATEX2MAN} -t $(macros) $(tmp) $$i.1) && gzip -f $$i.1; \
	done
	rm $(vtmp) $(tmp)

html-manpages:
	echo "\setVersion{`cat ../VERSION`}" > $(vtmp)
	echo "\setDate{`date +"%B, %Y"`}" >> $(vtmp)
	for i in $(targets); do \
	  (cat $(hdr) $(vtmp) $$i.latex2man $(ftr) > $(tmp) && \
	   ${LATEX2MAN} -H -t $(macros) $(tmp) $$i.html); \
	done
	rm $(vtmp) $(tmp)

latex-manpages:
	echo "\setVersion{`cat ../VERSION`}" > $(vtmp)
	echo "\setDate{`date +"%B, %Y"`}" >> $(vtmp)
	for i in $(targets); do \
	  (cat $(hdr) $(vtmp) $$i.latex2man $(ftr) > $(tmp) && \
	   ${LATEX2MAN} -L $(tmp) $$i.tex) && \
	   echo '\\end{document}' >> $$i.tex; \
	done
	rm $(vtmp) $(tmp)

clean:
	for i in $(targets); do \
	  rm -f $$i.tex $$i.html; \
	done

distclean: clean
	for i in $(targets); do \
	  rm -f $$i.1.gz; \
	done

.PHONY: default clean distclean

=== test/plugin/applic-delayed-ckpt/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_plugin-to-announce-events

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = plugin-to-announce-events.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -fPIC -I${DMTCP_INCLUDE}
override CXXFLAGS += -fPIC -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so applic

# NOTE:  ${CFLAGS} expands to invoke '-fPIC -I${DMTCP_INCLUDE}'
#        This is required for use with DMTCP.
applic: applic.c
	${CC} ${CFLAGS} -o $@ $< -ldl

check: ${LIBNAME}.so applic
	@ echo ""
	@ echo "============ TESTING ./applic _WITHOUT_ DMTCP ================"
	- ./applic
	@ echo '(Application has exited.)'
	@ echo ""
	@ sleep 3
	@ echo "============ TESTING ./applic WITH DMTCP ================="
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	# --interval 2 flag will write checkpoint every two seconds.
	${DMTCP_ROOT}/bin/dmtcp_launch --quiet --coord-port ${DEMO_PORT} \
	  --interval 2 --with-plugin $$PWD/${LIBNAME}.so ./applic &
	@ sleep 7
	@ echo ""
	@ ${DMTCP_ROOT}/bin/dmtcp_command --coord-port ${DEMO_PORT} -s || echo "NO COORDINATOR"
	@ echo "===== RESTARTING USING ./dmtcp_restart_script.sh ============="
	./dmtcp_restart_script.sh
	@ echo ""
	@ echo "ALL TESTS SUCCEEDED"

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so applic

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== test/plugin/applic-initiated-ckpt/Makefile ===
# To demonstrate, do:  make check    [Checkpoints every 5 seconds]

# The name will be the same as the current directory name.
NAME=${shell basename $$PWD}

# By default, your resulting plugin library will have this name.
LIBNAME=libdmtcp_plugin-to-announce-events

# As you add new files to your plugin library, add the object file names here.
LIBOBJS = plugin-to-announce-events.o

# Modify if your DMTCP_ROOT is located elsewhere.
ifndef DMTCP_ROOT
  DMTCP_ROOT=../../..
endif
DMTCP_INCLUDE=${DMTCP_ROOT}/include

override CFLAGS += -fPIC -I${DMTCP_INCLUDE}
override CXXFLAGS += -fPIC -I${DMTCP_INCLUDE}
LINK = ${CC}

DEMO_PORT=7781

default: ${LIBNAME}.so applic

# NOTE:  ${CFLAGS} expands to invoke '-fPIC -I${DMTCP_INCLUDE}'
#        This is required for use with DMTCP.
applic: applic.c
	${CC} ${CFLAGS} -o $@ $< -ldl

check: ${LIBNAME}.so applic
	@ echo ""
	@ echo "============ TESTING ./applic _WITHOUT_ DMTCP ================"
	- ./applic
	@ echo '(Application has exited.)'
	@ echo ""
	@ sleep 3
	@ echo "============ TESTING ./applic WITH DMTCP ================="
	# Kill an old coordinator on this port if present, just in case.
	@ ${DMTCP_ROOT}/bin/dmtcp_command --quit --quiet \
	  --coord-port ${DEMO_PORT} 2>/dev/null || true
	${DMTCP_ROOT}/bin/dmtcp_launch --quiet --coord-port ${DEMO_PORT} \
	  --with-plugin $$PWD/${LIBNAME}.so ./applic
	@ echo ""
	@ sleep 5
	@ echo "===== RESTARTING USING ./dmtcp_restart_script.sh ============="
	./dmtcp_restart_script.sh
	@ echo ""
	@ echo "ALL TESTS SUCCEEDED"

${LIBNAME}.so: ${LIBOBJS}
	${LINK} -shared -fPIC -o $@ $^

.c.o:
	${CC} ${CFLAGS} -c -o $@ $<
.cpp.o:
	${CXX} ${CXXFLAGS} -c -o $@ $<

tidy:
	rm -f *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

clean: tidy
	rm -f ${LIBOBJS} ${LIBNAME}.so applic

distclean: clean
	rm -f ${LIBNAME}.so *~ .*.swp dmtcp_restart_script*.sh ckpt_*.dmtcp

dist: distclean
	dir=`basename $$PWD`; cd ..; \
	  tar czvf $$dir.tar.gz --exclude-vcs ./$$dir
	dir=`basename $$PWD`; ls -l ../$$dir.tar.gz

.PHONY: default clean dist distclean

=== debian/changelog ===
dmtcp (2.4.0-1) unstable; urgency=medium

  * New upstream release 2.4.0.
  * Support for ARM64 (closes: #791940).
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Wed, 15 Jul 2015 10:01:42 -0400

dmtcp (2.3.1-5) unstable; urgency=low

  * Removed armhf architecture support from dmtcp-dbg as well.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 26 Jul 2014 09:58:35 -0400

dmtcp (2.3.1-4) unstable; urgency=low

  * Removed armel architecture support.
  * Remove previously added -march=armv7 for ARM builds.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Fri, 25 Jul 2014 16:19:26 -0400

dmtcp (2.3.1-3) unstable; urgency=low

  * Added armhf architecture support.
  * Force -march=armv7 for ARM builds.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 24 Jul 2014 11:50:36 -0400

dmtcp (2.3.1-2) unstable; urgency=low

  * Compilation fix for older ARM CPUs.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 19 Jul 2014 13:42:49 -0400

dmtcp (2.3.1-1) unstable; urgency=low

  * New upstream release 2.3.1 (closes: #662910).
  * Remove stale dependency on libmtcp1 (closes: #753764).
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Mon, 14 Jul 2014 18:56:41 -0400

dmtcp (2.2-1) unstable; urgency=low

  * New upstream release 2.2.
  * Changing distribution from experimental to unstable.
  * Updated debian standards version to 3.9.5.
  * Removed libmtcp and libdmtcpaware packages.
  * Run make check in "slow" mode.
  * Updated copyright file.
  * Added debian/NEWS file.
  * Removed some stale files from install procedure.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 11 Jan 2014 23:47:45 -0500

dmtcp (1.2.7-1) experimental; urgency=low

  * Preparing for upstream Release 1.2.7.
  * Vcs-svn and Vcs-browser URLs updated.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 14 Mar 2013 07:10:34 -0400

dmtcp (1.2.5-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.5.
  * debhelper version changed from >=9 to >=7 to accommodate older distros.
  * Standards version changed to 3.9.3. 
  * configure command line updated to include dkpg-buildflags.
  * Added lintian overrides for libmtcp1, dmtcp and libdmtcpaware1 to suppress
    hardening false positives.
  * ARM support added.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 26 May 2012 22:54:33 -0400

dmtcp (1.2.4-1) unstable; urgency=low

  * Preparing for upstream Release 1.2.4.
  * New binary packages libmtcp1 and libmtcp1-dev created.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Mon, 24 Jan 2012 17:00:11 -0500

dmtcp (1.2.1-2) unstable; urgency=low

  * Fixing compilation errors for gcc/g++ 4.6.
  * Fixing compilation errors related to PAGE_SIZE and PAGE_MASK macros.
  * Call "make check" towards the end of build-stamp.
  * Add python to build-deps.
  * Standards Version boosted to 3.9.2.
  * Templates removed from debian/watch.
  * Leading "./" removed from lintian-overrides.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Tue, 31 May 2011 00:17:42 -0400

dmtcp (1.2.1-1) unstable; urgency=low

  * Preparing for upstream release 1.2.1. 

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:41:11 -0500

dmtcp (1.2.0+svn937-1) unstable; urgency=low

  * Updating libdmtcpaware1.symbols to reflect the proper version.
  * Updating watch file to point to proper package name

 -- Kapil Arya <kapil@ccs.neu.edu>  Sat, 12 Mar 2011 17:10:02 -0500

dmtcp (1.2.0+svn923-1) unstable; urgency=low

  * Adding debian/libdmtcpaware1.symbols file.
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Wed, 09 Mar 2011 02:03:21 -0500

dmtcp (1.2.0+svn876-1) unstable; urgency=low

  * Initial release (Closes: #610653)
  * Upload sponsored by Yaroslav Halchenko <debian@onerussian.com>

 -- Kapil Arya <kapil@ccs.neu.edu>  Thu, 03 Feb 2011 09:52:24 -0500

=== debian/control ===
Source: dmtcp
Section: utils
Priority: optional
Maintainer: Kapil Arya <kapil@ccs.neu.edu>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>
Build-Depends: debhelper (>= 7), python
Standards-Version: 3.9.5
Vcs-git: https://github.com/dmtcp/dmtcp.git
Vcs-browser: https://github.com/dmtcp/dmtcp
Homepage: http://dmtcp.sourceforge.net

Package: dmtcp
Architecture: i386 amd64 armhf arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Checkpoint/Restart functionality for Linux processes
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to
 transparently checkpointing the state of an arbitrary group of
 applications including multi-threaded and distributed computations.
 It operates directly on the user binary executable, with no Linux kernel
 modules or other kernel mods.
 .
 Among the applications supported by DMTCP are Open MPI, MVAPICH2, MATLAB,
 R, Python, Perl, and many programming languages and shell scripting
 languages.  It supports both TCP sockets and InfiniBand connections.
 With the use of TightVNC, it can also checkpoint and restart X-Window
 applications.  The OpenGL library for 3D graphics is supported through
 a special plugin.
 .
 This package contains DMTCP binaries.

Package: dmtcp-dbg
Architecture: i386 amd64 armhf arm64
Section: debug
Priority: extra
Depends: dmtcp, ${misc:Depends}
Description: Debug package for dmtcp
 DMTCP (Distributed MultiThreaded Checkpointing) is a tool to
 transparently checkpointing the state of an arbitrary group of
 applications including multi-threaded and distributed computations.
 It operates directly on the user binary executable, with no Linux kernel
 modules or other kernel mods.
 .
 Among the applications supported by DMTCP are Open MPI, MVAPICH2, MATLAB,
 R, Python, Perl, and many programming languages and shell scripting
 languages.  It supports both TCP sockets and InfiniBand connections.
 With the use of TightVNC, it can also checkpoint and restart X-Window
 applications.  The OpenGL library for 3D graphics is supported through
 a special plugin.
 .
 This package contains debugging symbols for DMTCP.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

DPKG_BUILD_VERSION= $(shell dpkg-buildflags --version | sed -ne '1s,.*version *,,gp')
ifeq ($(shell dpkg --compare-versions 1.16.1 lt $(DPKG_BUILD_VERSION) && echo TRUE), TRUE)
DPKG_BUILDFLAGS= $(shell dpkg-buildflags --export=configure)
else
DPKG_BUILDFLAGS= CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="-Wl,-z,defs"
endif

BUILDDIR = debian/tmp
DESTDIR = $(CURDIR)/$(BUILDDIR)


configure: configure-stamp
configure-stamp:
	dh_testdir
	./configure $(CROSS) --prefix=/usr --mandir=\$${prefix}/share/man --infodir=\$${prefix}/share/info $(DPKG_BUILDFLAGS)

	touch configure-stamp

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp

build-stamp: configure-stamp  
	dh_testdir

	$(MAKE)
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(shell dpkg-architecture -qDEB_BUILD_ARCH_CPU),arm)
	env PWD=`pwd` ./test/autotest.py
endif
endif

	touch $@

clean: 
	dh_testdir
	rm -f build-stamp configure-stamp

	[ ! -f Makefile ] || $(MAKE) distclean

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep  
	dh_installdirs
	dh_lintian

	# Add here commands to install the package into debian/dmtcp.
	$(MAKE) DESTDIR=$(DESTDIR) install

	dh_install -XCOPYING --fail-missing --sourcedir=$(BUILDDIR)


# Build architecture-independent files here.
binary-indep: install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
	dh_installman
	dh_link
	dh_strip --dbg-package=dmtcp-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
